
;   (c) Copyright 1999,  Byon Garrabrant,  N6BG.  
;       All rights reserved.
;       Much of the program contains code copied from
;       N6BG.        Thanks Byon
;-----------------------------------------------------------
;       N0QBH's                                         7/99
;               Programable manual packet beacon
;               For 10 Mhz PIC-E chassis
;               Switch #1 - Left til valid lites, then right
;               sends packet.
;------------------------------------------------------------
        list    p=PIC16F84
        radix   hex
        __config h'3ff1'
;------------------------------------------------------------
        include "P16F84.INC"            ;standard names
;____________________________________________________________
        cblock  H'0c'                   ;variables
                temp                    ;buffer
                count                   ;counter
                count_one               ;counter
                ax25_temp               ;flag counter
                ax25_sending_char       ;data byte
                ax25_sending_count      ;data bit counter
                ax25_bit_history        ;for bit stuffing
                ax25_crc_hi             ;for CRC
                ax25_crc_lo             ;for CRC
                FLAGS                   ;sent bit :1
                next_freq               ;toggles 0/1
                intWsave                ;interrupt flags
                intSTATUSsave
                intPCLATHsave
        endc
;------------------------------------------------------------
;               Port set-up
#define SENT                    FLAGS,1
#define PTT_OUT                 PORTA,2
#define TOGGLE                  PORTA,4
#define VALID                   PORTB,0
#define MODE1_OUT               PORTB,1
#define MODE0_OUT               PORTB,2
#define DCD                     PORTB,3
#define TONE_OUT                PORTB,5
;------------------------------------------------------------
        ORG     H'0000'
        goto    main
        ORG     H'0004'
        goto    Timer_Interrupt
;------------------------------------------------------------
;Edit MYCALL with your callsign, add spaces if it's less
;than 6 chars long.  SSID can changed by editing the ones
;digit in 0x30 following MYCALL. 0x30=0 0x3f=15
;Default path is RELAY,WIDE,WIDE
;
to_list
        addwf   PCL,f
        dt      "APRS: ",0x30           ;destination
        dt      "MYCALL",0x30           ;org station call-0
        dt      "RELAY ",0x30           ;data left shifted
        dt      "WIDE  " 0x30           ;one bit, LSB clear
        dt      "WIDE  "                ;last SSID (0) sent
        dt      0                       ;left shifted,LSB set
;
;Don't include SSID on last digi.  Program does it.
;------------------------------------------------------------
the_gist
        addwf   PCL,f
        dt      0x03,0xf0               ;packet type H030f
;
        dt      "Look Ma - No TNC! - PIC Packet"
        dt      0
;
;Edit your info in quotes after the 2nd dt (define table).
;------------------------------------------------------------
main    
        bsf     STATUS,RP0              ;bank 1
        movlw   b'11111000'             ;A:3,A:4 inputs
        movwf   TRISA                   ;set up port A I/O
        movlw   b'00001000'             ;B:3 input
        movwf   TRISB                   ;set up port B I/O
        bcf     STATUS,RP0              ;bank 0
        call    Tone_Init               ;init the modem
check_tog_set
        btfss   TOGGLE                  ;toggle set ?
        goto    check_tog_set           ;no, go back
        call    qtr_sec_delay           ;yes, wait .26 sec
        btfss   TOGGLE                  ;still set ?
        goto    check_tog_set           ;no, go back
        bsf     VALID                   ;turn on valid LED
check_tog_clr
        btfsc   TOGGLE                  ;toggle clear ?
        goto    check_tog_clr           ;no
check_dcd                               ;yes, send packet
        call    qtr_sec_delay           ;wait .26 sec
        btfsc   DCD                     ;check DCD pin
        goto    check_dcd
        clrf    count                   ;yes,reset count
        movlw   d'40'                   ; 40 flags
        movwf   ax25_temp               ;for tx delay
        bsf     PTT_OUT                 ;assert PTT
        call    AX25_Send_Start         ;send flags for txd
to_list_loop
        movfw   count                   ;start pointer to W
        call    to_list                 ;get next byte
        movwf   temp                    ;copy to temp
        iorlw   0                       ;test for zero
        skpnz
        goto    to_list_last            ;zero, send last SSID
        clrc                            ;clear carry
        rlf     temp,f                  ;shift left
        movfw   temp                    ;reload W
        call    AX25_Send_Data          ;send byte
        incf    count,f                 ;inc offset counter
        goto    to_list_loop            ;get next
;------------------------------------------------------------
to_list_last
        movlw   0x30                    ;ascii zero
        movwf   temp
        setc                            ;set carry
        rlf     temp,f                  ;shift left
        movfw   temp
        call    AX25_Send_Data          ;send last SSID
        clrf    count                   ;reset count
;------------------------------------------------------------
send_the_gist
        movfw   count                   ;load offset
        call    the_gist                ;look up byte
        movwf   temp                    ;store
        iorlw   0                       ;test for zero
        skpnz
        goto    finish_up               ;zero, done
        movfw   temp                    ;temp to W
        call    AX25_Send_Data          ;send byte
        incf    count,f                 ;inc pointer
        goto    send_the_gist           ;get next
;------------------------------------------------------------
finish_up
        call    AX25_Send_End
        bcf     PTT_OUT                 ;un-key
        bcf     VALID                   ;turn off valid LED
        goto    check_tog_set           ;start over
;
;-------------------------------------------------------------
AX25_Send_Bit
        rlf     ax25_bit_history, F     ; store  last 8 bits
	rrf	ax25_bit_history, W	; restore the bit
	call	Tone_Toggle_If_No_Carry
        comf    ax25_bit_history, W     ; check last 5 bits
	andlw	H'1F'
 	skpz				; if not all 1s
        return                          ; return
        clrc                            ; send a 0 bit
	goto	AX25_Send_Bit			
;____________________________________________________________
AX25_Send_Flag:
        movlw   H'7E'                   ;B'01111110'
        movwf   ax25_sending_char       ;to send register
        movlw   8                       ;number of bits
        movwf   ax25_sending_count      ;to send counter
AX25_Send_Flag_Loop
	rrf	ax25_sending_char, F	; get bit for sending
 	call	AX25_Send_Bit
	clrf	ax25_bit_history	; no bit stuffing for flags
	decfsz	ax25_sending_count, F
        goto    AX25_Send_Flag_Loop
	return 
;____________________________________________________________
AX25_Send_Start
	call	Tone_Enable		; start tone
AX25_Send_Start_Flag_Loop
	call	AX25_Send_Flag
	decfsz	ax25_temp, F
        goto   AX25_Send_Start_Flag_Loop
	movlw	H'FF'			; crc inits to 0xFFFF
	movwf	ax25_crc_hi
	movwf	ax25_crc_lo
	return
;____________________________________________________________
AX25_Send_Data
	movwf	ax25_sending_char
	movlw	8
	movwf	ax25_sending_count
AX25_Send_Data_Loop
	rrf	ax25_sending_char, W	; get bit for CRC
	movlw	1
	skpnc
        xorwf  ax25_crc_lo, F           ; crc ^= d & 1;
	clrc
	rrf	ax25_crc_hi, F
	rrf	ax25_crc_lo, F
	skpc
        goto   AX25_CRC_Done
	movlw	H'08'
	xorwf	ax25_crc_lo, F
	movlw	H'84'
        xorwf   ax25_crc_hi, F
AX25_CRC_Done
	rrf	ax25_sending_char, F	; get bit for sending
 	call	AX25_Send_Bit
	decfsz	ax25_sending_count, F
        goto   AX25_Send_Data_Loop
	return 
;____________________________________________________________
AX25_Send_End
	movlw	H'FF'			; send CRC
	xorwf	ax25_crc_lo, F		; invert lo
	xorwf	ax25_crc_hi, W		; invert hi and
	movwf	ax25_temp		; save in temp
	movfw	ax25_crc_lo		; send lo
	call	AX25_Send_Data
	movfw	ax25_temp		; send hi
	call	AX25_Send_Data
	call	AX25_Send_Flag		; send final flags
	call	AX25_Send_Flag		; send final flags
	call	Tone_Disable		; stop tone
	return
;____________________________________________________________
Timer_Interrupt
        movwf   intWsave                ; save W
        swapf   STATUS, W               ; save STATUS
        movwf   intSTATUSsave
        movfw   PCLATH                  ; save PCLATH
        movwf   intPCLATHsave
        bcf     STATUS, RP0             ; select bank 0
        movlw   D'130'                  ; bump timer forward
        subwf   TMR0, F                 ; update TMR0 for next int
        bsf     SENT                    ; ready for the next bit
;
timer_end
        bcf     INTCON, T0IF            ; enable TMR0 int
        movfw   intPCLATHsave           ; restore PCLATH
        movwf   PCLATH                  
        swapf   intSTATUSsave, W        ; restore STATUS
        movwf   STATUS
        swapf   intWsave, F             ; restore W
        swapf   intWsave, W
        retfie                          ; return from interrupt
;____________________________________________________________
Tone_Init
        clrf    INTCON
        bcf     PTT_OUT                 ;clear PTT pin
        bcf     VALID                   ;clear valid pin
        bcf     SENT                    ;clear sent flag
Tone_Disable
        bcf     INTCON, T0IE            ; disableTMR0int
        bsf     STATUS, RP0             ; Select Bank 1
        movlw   b'11010111'             ; divide TMR0 by 256
        movwf   OPTION_REG              ; enable TMR0
        bcf     STATUS, RP0             ; Select Bank 0
        bcf     INTCON, GIE             ; disable ints
        bsf     MODE1_OUT               ; disable audio tone
        bcf     MODE0_OUT               ; disable audio tone
        bcf     TONE_OUT                ; disable audio tone
        return
Tone_Enable
        bsf     STATUS, RP0             ; Select Bank 1
        movlw   b'11010011'             ; div by 16
        movwf   OPTION_REG              ; enable TMR0
        bcf     STATUS, RP0             ; Select Bank 0
        bsf     INTCON, T0IE            ; enableTMR0int
        bsf     INTCON, GIE             ; enable ints
        clrf    next_freq               ; set initial freq
        bcf     MODE1_OUT               ; enable audio tone
        bsf     MODE0_OUT               ; enable audio tone
        return
;____________________________________________________________
Tone_Toggle_If_No_Carry
        btfss   SENT                    ; wait last bit sent
        goto    Tone_Toggle_If_No_Carry
        bcf     SENT                    ; next bit is ready
        skpnc                           ; if sending a 1
        return                          ; leave
        incf    next_freq, F            ; set new
        btfsc   next_freq, 0
        bsf    TONE_OUT
        btfss   next_freq, 0
        bcf    TONE_OUT
        return
;------------------------------------------------------------
;                    (((2.5M /256) /256) /10)
qtr_sec_delay
        movlw   D'10'
        movwf   count_one
        bcf     INTCON,T0IF             ;clear timer flag
timer_overflow
        btfss   INTCON,T0IF             ;flag set ?
        goto    timer_overflow          ;no, look again
        bcf     INTCON,T0IF             ;yes, clear it
        decfsz  count_one,F             ;count_one -1
        goto    timer_overflow
        return
;------------------------------------------------------------
        end
;____________________________________________________________

